import java.net.*;
import java.io.*;

public class Finger {
  public final static int port = 79;

  java.util.Vector msgs = new java.util.Vector();

  // return message...
  String[] run(String hostname) {
    Socket theSocket;
    BufferedReader theFingerStream;
    PrintStream ps;
    String[] messages;

    try {
      theSocket = new Socket(hostname, port);
      ps = new PrintStream(theSocket.getOutputStream());

      ps.print("\n");
      theFingerStream = 
	new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
      String s;
      while((s = theFingerStream.readLine()) != null) {
	msgs.addElement(s);
      }
    }
    catch (IOException e) {
      System.err.println(e);
    }

    messages = new String[msgs.size()];
    for(int i = 0; i < msgs.size(); i++) {
      messages[i] = " " + (String)msgs.elementAt(i);
    }

    return messages;
  }

  void printResult(String[] messages) {
    for(int i = 0; i < messages.length; i++) {
      System.out.println(messages[i]);
    }
  }

  public static void main(String[] args) {
    String hostname;

    try {
      hostname = args[0];
    }
    catch (Exception e) {
      hostname = "localhost";
    }

    Finger doIt = new Finger();
    doIt.printResult(doIt.run(hostname));
  }
}
